/*+-------------------------------------------------------------------------------------+*/
/*|			F																		|*/
/*|	NX	FCRs232c																|*/
/*|	t@CTvFRS232cp̃NX													|*/
/*|	TAB			F4																		|*/
/*|			F1997.01.10`	cFiSSEj	VK쐬								|*/
/*|				F1998.05.07	@iSSEj	NX								|*/
/*|	Copyright	F1997-1998 Sanki System Engineering Co.Ltd.							|*/
/*+-------------------------------------------------------------------------------------+*/

/* VA|[g\ */
typedef struct {
    DWORD BaudRate;       /* {[[g(ex 9600, 14400, ...) */
    BYTE ByteSize;        /* Number of bits/byte, 4-8        */
    BYTE Parity;          /* 0-4=None,Odd,Even,Mark,Space    */
    BYTE StopBits;        /* 0,1,2 = 1, 1.5, 2               */
} INIT_COMM_PAC;

/*+-------------------------------------------------------------------------------------+*/
/*|	TvFRs232cNX																	|*/
/*|	F																				|*/
/*|	F1997.01.10`	cFiSSEj	VK쐬										|*/
/*|		F1998.05.07	@iSSEj	NX										|*/
/*|	dlF																				|*/
class CRs232c
{
	///////////////////////////////////////////////////////////////////////////
	//	Life Cycle

	//	Birth
	public:
	CRs232c::CRs232c();
	CRs232c::CRs232c(char*, int r_nInputBuffer = 2000, int r_nOutputBuffer = 2000);

	//	Death
	CRs232c::~CRs232c();

	///////////////////////////////////////////////////////////////////////////
	//	Operator

	///////////////////////////////////////////////////////////////////////////
	//	Data

	//	public data
	public:

	//	protected data
	protected:
	HANDLE m_hCom;									//
	HANDLE m_hRead;									//
	HANDLE m_hWrite;								//

	int m_nInputBuffer;								// ̓obt@
	int m_nOutputBuffer;							// o̓obt@

	//	private data
	private:

	///////////////////////////////////////////////////////////////////////////
	//	Function

	//	public Function
	public:
		BOOL OpenCommPort(char*, int r_nInputBuffer = 2000, int r_nOutputBuffer = 2000);
		void CloseCommPort();

		BOOL InitCommPort(INIT_COMM_PAC*);

		int ReadComm(DWORD ,LPSTR);
		int ReadCommBlock(LPSTR, int);

		BOOL WriteCommBlock(LPSTR, DWORD);

		UCHAR GetBcc(LPSTR, UCHAR);

	//	protected Function
	protected:

	//	private Function
	private:


};
/*+-------------------------------------------------------------------------------------+*/
