// TC2MesDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "tc2s.h"
#include "tccont.h"
#include "TC2MesDlg.h"
#include "condition.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern SCondition condition;					// Ŝ̑
/////////////////////////////////////////////////////////////////////////////
// CTC2MesDlg _CAO


CTC2MesDlg::CTC2MesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTC2MesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTC2MesDlg)
	//}}AFX_DATA_INIT
	m_bComplete = FALSE;
	m_lLoopTimes = 0l;
	m_strTitle = "";
}

BOOL CTC2MesDlg::Create()
{
	m_bBreak = FALSE;							// f׸޸ر
	return CDialog::Create(CTC2MesDlg::IDD);
} 

void CTC2MesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTC2MesDlg)
	DDX_Control(pDX, IDC_ST_MESY, m_stMesY);
	DDX_Control(pDX, IDC_ST_MESV, m_stMesV);
	DDX_Control(pDX, IDC_ST_MESSAGE, m_stMessage);
	DDX_Control(pDX, IDC_ST_MESP, m_stMesP);
	DDX_Control(pDX, IDC_ST_MESH, m_stMesH);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTC2MesDlg, CDialog)
	//{{AFX_MSG_MAP(CTC2MesDlg)
	//}}AFX_MSG_MAP
	ON_MESSAGE(ID_MEASURE_START, OnMeasureStart )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTC2MesDlg bZ[W nh

BOOL CTC2MesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	tc2.Tc2Setup();		//RS232C-Setup

	m_stMessage.SetWindowText("f[^擾{^ŊJn_̃f[^ǂݍ݂܂B");	
	return TRUE;
}

// -------------------------------------------------------------------------
//		Ӱڽ޲۸ޯ
// -------------------------------------------------------------------------
LONG CTC2MesDlg::OnMeasureStart( UINT wParam, LONG lParam )
{
	return 0L;
}

// -------------------------------------------------------------------------
//		Cancel {^
// -------------------------------------------------------------------------
void CTC2MesDlg::OnCancel() 
{
	tc2.Tc2Close();
	m_bBreak = TRUE;
	CDialog::OnCancel();
}

static float dummyData[] = {
	10.0f,60.0f,05.0f,60.0f,22.0f,92.0f,70.0f,60.0f,55.0f,62.0f,77.0f,02.0f,37.0f,82.0f,32.0f,95.0f,
	60.0f,10.0f,60.0f,05.0f,60.0f,22.0f,92.0f,70.0f,60.0f,55.0f,62.0f,77.0f,02.0f,37.0f,82.0f,32.0f
	};
// -------------------------------------------------------------------------
//		f[^擾 {^
// -------------------------------------------------------------------------
void CTC2MesDlg::OnOK() 
{
	CString strMess;
	float	fH, fV, fY, fP;
	
	if( m_lLoopTimes <= condition.m_wDivn )		//KJԂ
	{
		sprintf( strMess.GetBuffer(50), "_@%3d@_ڂ̑sȂ܂B", m_lLoopTimes );
		m_stMessage.SetWindowText( strMess );

		if( condition.m_bDebug == TRUE )
		{
			*(m_pHData + m_lLoopTimes) = dummyData[ m_lLoopTimes + 0 ];
			*(m_pVData + m_lLoopTimes) = dummyData[ m_lLoopTimes + 2 ];
			*(m_pYData + m_lLoopTimes) = dummyData[ m_lLoopTimes + 4 ];
			*(m_pPData + m_lLoopTimes) = dummyData[ m_lLoopTimes + 6 ];
			*(m_pXData + m_lLoopTimes) = (float)m_lLoopTimes + 1;
		}
		else {
			tc2.Tc2GetData( &fH, &fV, &fY, &fP );		//Tc2 Data Get
			Sleep(300);
			tc2.Tc2GetData( &fH, &fV, &fY, &fP );		//Tc2 Data Get
			*(m_pHData + m_lLoopTimes) = fH / 100.0f;
			*(m_pVData + m_lLoopTimes) = fV / 100.0f;
			*(m_pYData + m_lLoopTimes) = fY / 100.0f;
			*(m_pPData + m_lLoopTimes) = fP / 100.0f;
			*(m_pXData + m_lLoopTimes) = (float)m_lLoopTimes;
		}

		sprintf( strMess.GetBuffer(50), "%6.2f", *(m_pHData  + m_lLoopTimes)); m_stMesH.SetWindowText( strMess );
		sprintf( strMess.GetBuffer(50), "%6.2f", *(m_pVData  + m_lLoopTimes)); m_stMesV.SetWindowText( strMess );
		sprintf( strMess.GetBuffer(50), "%6.2f", *(m_pYData  + m_lLoopTimes)); m_stMesY.SetWindowText( strMess );
		sprintf( strMess.GetBuffer(50), "%6.2f", *(m_pPData  + m_lLoopTimes)); m_stMesP.SetWindowText( strMess );
		sprintf( strMess.GetBuffer(50), "_@%3d@_ڂ̑IłB", m_lLoopTimes );
		m_stMessage.SetWindowText( strMess );
		m_lLoopTimes++;							//̓_҂
		if( m_lLoopTimes > condition.m_wDivn )	//KJԂ
		{
			tc2.Tc2Close();
			m_bComplete = TRUE;
			CDialog::OnOK();
		}
	}
	else {										//萳I
		tc2.Tc2Close();
		m_bComplete = TRUE;
		CDialog::OnOK();
	}
}

