// tc2sDoc.cpp : CTc2sDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "float.h"
#include "tc2s.h"
#include "condition.h"

#include "tc2sDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern SCondition condition;					// Ŝ̑
/////////////////////////////////////////////////////////////////////////////
// CTc2sDoc

IMPLEMENT_DYNCREATE(CTc2sDoc, CDocument)

BEGIN_MESSAGE_MAP(CTc2sDoc, CDocument)
	//{{AFX_MSG_MAP(CTc2sDoc)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTc2sDoc NX̍\z/

CTc2sDoc::CTc2sDoc()
{
	m_nData=0;
}

CTc2sDoc::~CTc2sDoc()
{
}

BOOL CTc2sDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;


	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CTc2sDoc VAC[[V

void CTc2sDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar	<< m_nData					// ް
			<< m_fStart					// XJnl
			<< m_fEnd					// XIl
			<< m_fStep					// XԊu
			<< m_fMinH					// H@ŏl
			<< m_fMaxH					// H@ől
			<< m_fMinV					// H@ŏl
			<< m_fMaxV					// H@ől
			<< m_fMinY					// H@ŏl
			<< m_fMaxY					// H@ől
			<< m_fMinP					// H@ŏl
			<< m_fMaxP;					// H@ől

		ar.Write( m_aHData, sizeof( float ) * m_nData);
		ar.Write( m_aVData, sizeof( float ) * m_nData);
		ar.Write( m_aYData, sizeof( float ) * m_nData);
		ar.Write( m_aPData, sizeof( float ) * m_nData);

	}
	else
	{
		ar	>> m_nData					// ް
			>> m_fStart					// XJnl
			>> m_fEnd					// XIl
			>> m_fStep					// XԊu
			>> m_fMinH					// H@ŏl
			>> m_fMaxH					// H@ől
			>> m_fMinV					// H@ŏl
			>> m_fMaxV					// H@ől
			>> m_fMinY					// H@ŏl
			>> m_fMaxY					// H@ől
			>> m_fMinP					// H@ŏl
			>> m_fMaxP;					// H@ől

		if( SetMeasurePara() == FALSE ) {
			MessageBox( NULL, "̈悪mۂł܂łB", "WARNING", MB_OK | MB_ICONEXCLAMATION );
			return;						// ǂݍ݂Ȃ
		}

		ar.Read( m_aHData, sizeof( float ) * m_nData);
		ar.Read( m_aVData, sizeof( float ) * m_nData);
		ar.Read( m_aYData, sizeof( float ) * m_nData);
		ar.Read( m_aPData, sizeof( float ) * m_nData);
		
		SetMeasureData();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTc2sDoc NX̐ff

#ifdef _DEBUG
void CTc2sDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTc2sDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTc2sDoc R}h
// --------------------------------------------------------------------------
//		ްi[pذ̊m
// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
//		Oɏݒ肷
// --------------------------------------------------------------------------
BOOL CTc2sDoc::SetMeasurePara()
{
	DWORD dwSize;

	RleaseDataArea();// 
	dwSize = DWORD( ( condition.m_wDivn + 10 ) * sizeof(float));
	if( GetDataArea( dwSize ) == FALSE )
		return FALSE;
	m_Date = CTime::GetCurrentTime();			// ݎ𓾂
	m_strSample = condition.m_sName;
	return TRUE;
}

// --------------------------------------------------------------------------
//		̌ʌvZ
// --------------------------------------------------------------------------
BOOL CTc2sDoc::SetMeasureData()
{
	m_fMinH = GetMin( 1 ); 	m_fMaxH = GetMax( 1 );
	m_fMinV = GetMin( 2 ); 	m_fMaxV = GetMax( 2 );
	m_fMinY = GetMin( 3 ); 	m_fMaxY = GetMax( 3 );
	m_fMinP = GetMin( 4 ); 	m_fMaxP = GetMax( 4 );
	
	m_fMaxYs = ( m_fMaxH  > m_fMaxV)? m_fMaxH:m_fMaxV;
	m_fMaxYs = ( m_fMaxYs > m_fMaxY)? m_fMaxYs:m_fMaxY;
	m_fMaxYs = ( m_fMaxYs > m_fMaxP)? m_fMaxYs:m_fMaxP;

	m_fMinYs = ( m_fMinH  < m_fMinV)? m_fMinH:m_fMinV;
	m_fMinYs = ( m_fMinYs < m_fMinY)? m_fMinYs:m_fMinY;
	m_fMinYs = ( m_fMinYs < m_fMinP)? m_fMinYs:m_fMinP;

	m_fStart = 1.0;
	m_fStep = 1.0;
	m_fEnd = m_fStart + m_fStep * m_nData;

	return TRUE;
}

// --------------------------------------------------------------------------
//		m
// --------------------------------------------------------------------------
BOOL CTc2sDoc::GetDataArea( DWORD dwSize )
{
	BOOL	bRet = TRUE;

	m_hXData = GlobalAlloc( GMEM_MOVEABLE, dwSize );
	m_hHData = GlobalAlloc( GMEM_MOVEABLE, dwSize );
	m_hVData = GlobalAlloc( GMEM_MOVEABLE, dwSize );
	m_hYData = GlobalAlloc( GMEM_MOVEABLE, dwSize );
	m_hPData = GlobalAlloc( GMEM_MOVEABLE, dwSize );
	if( m_hXData == NULL || m_hHData == NULL || m_hVData == NULL || m_hYData == NULL || m_hPData == NULL )
	{				// ްpذmۂłȂ
		m_aXData = (float*)NULL;
		m_aHData = (float*)NULL;
		m_aVData = (float*)NULL;
		m_aYData = (float*)NULL;
		m_aPData = (float*)NULL;
		GlobalFree( m_hXData );			// ɊmۂĂذ
		GlobalFree( m_hHData );
		GlobalFree( m_hVData );
		GlobalFree( m_hYData );
		GlobalFree( m_hPData );
	}
	m_aXData = (float*)GlobalLock( m_hXData );
	m_aHData = (float*)GlobalLock( m_hHData );
	m_aVData = (float*)GlobalLock( m_hVData );
	m_aYData = (float*)GlobalLock( m_hYData );
	m_aPData = (float*)GlobalLock( m_hPData );
	return bRet;
}

// --------------------------------------------------------------------------
//		
// --------------------------------------------------------------------------
void CTc2sDoc::RleaseDataArea()
{
	if( m_hXData != NULL ){
		GlobalUnlock( m_hXData ); 		GlobalFree( m_hXData );
		m_hXData = HGLOBAL( NULL );		m_aXData = (float*)NULL;
	}
	if( m_hHData != NULL ){
		GlobalUnlock( m_hHData ); 		GlobalFree( m_hHData );
		m_hHData = HGLOBAL( NULL );		m_aHData = (float*)NULL;
	}
	if( m_hVData != NULL ){
		GlobalUnlock( m_hVData ); 		GlobalFree( m_hVData );
		m_hVData = HGLOBAL( NULL );		m_aVData = (float*)NULL;
	}
	if( m_hYData != NULL ){
		GlobalUnlock( m_hYData ); 		GlobalFree( m_hYData );
		m_hYData = HGLOBAL( NULL );		m_aYData = (float*)NULL;
	}
	if( m_hPData != NULL ){
		GlobalUnlock( m_hPData ); 		GlobalFree( m_hPData );
		m_hPData = HGLOBAL( NULL );		m_aPData = (float*)NULL;
	}
}

// --------------------------------------------------------------------------
//		őlT ( typ: 0:H 1:V 2:Y 3:P )
// --------------------------------------------------------------------------
float CTc2sDoc::GetMax( int typ )
{
	float max =  -10000.0f;
	float* fTmp;

	switch( typ )
	{
		case 1: fTmp = m_aHData; break;
		case 2: fTmp = m_aVData; break;
		case 3: fTmp = m_aYData; break;
		case 4: fTmp = m_aPData; break;
		default:fTmp = m_aHData; break;
	}
	for( int i = 0; i < m_nData; fTmp++, i++){
		if( *fTmp > max )
			max = *fTmp;
	}
	return max;
}

// --------------------------------------------------------------------------
//		ŏlT ( typ: 0:H 1:V 2:Y 3:P )
// --------------------------------------------------------------------------
float CTc2sDoc::GetMin( int typ )
{
	float min = FLT_MAX;
	float* fTmp;
	switch( typ )
	{
		case 1: fTmp = m_aHData; break;
		case 2: fTmp = m_aVData; break;
		case 3: fTmp = m_aYData; break;
		case 4: fTmp = m_aPData; break;
		default:fTmp = m_aHData; break;
	}
	for( int i = 0; i < m_nData; fTmp++, i++){
		if( *fTmp < min )
			min = *fTmp;
	}
	return min;
}

// ---------------------------------------------------------------------
//		Text output Serial type
// ---------------------------------------------------------------------
void CTc2sDoc::SaveTextFile(char *fname)
{
FILE *fp;
int i;

	if((fp=fopen(fname,"wt"))!=NULL) {
		fprintf(fp,"TvOf[^,%d\n",m_nData);
		fprintf(fp,"------------------------------------------------------------\n");
		fprintf(fp,"Tv,%s\n",m_strSample);
		fprintf(fp,"t,%s\n",m_Date.Format("%y/%m/%d"));
		fprintf(fp,"Horizontal,Max,%7.2f,Min,%7.2f\n",m_fMaxH,m_fMinH);
		fprintf(fp,"Vertical,Max,%7.2f,Min,%7.2f\n",m_fMaxV,m_fMinV);
		fprintf(fp,"Yawing,Max,%7.2f,Min,%7.2f\n",m_fMaxY,m_fMinY);
		fprintf(fp,"Pitching,Max,%7.2f,Min,%7.2f\n",m_fMaxP,m_fMinP);
		fprintf(fp,"------------------------------------------------------------\n");
		fprintf(fp,"Times,Horizontal,Vertical,Yawing,Pitching\n");
		for( i=0;i<m_nData;i++)
			fprintf(fp,"%.0f,%8.2f,%8.2f,%8.2f,%8.2f\n",
				m_aXData[i],m_aHData[i],m_aVData[i],m_aYData[i],m_aPData[i]);
		fclose(fp);
	}
}



